c eigen.f
c Program pro vypocet vlastnich cisel a vlastnich vektoru.
c Jan 15th 2010

      program eigen

      integer np
      parameter(np = 10) ! maximalni rozmer matice

      integer n          ! skutecny rozmer vstupni matice
      real a(np,np)      ! vstupni matice (symetricka)
      real d(np)         ! diagonalni cleny tridiagonalni matice
      real e(np)         ! ostatni cleny pod diagonalou
c      real z(np,np)      ! na vstupu je vystup ze subrutiny tred  -> na vystupu vlastni vektory ve sloupci k!
      integer id(np)     ! pole indexu pro trideni vystupu

c nacteni symetricke matice ze standardniho vstupu
      write(*,*) '# pocet prvku n = '
      read(*,*) n
      write(*,*) n

      write(*,*) '# symetricka matice a(n,n) = '
      do i = 1, n
        read(*,*) (a(i,j), j = 1, n)
      enddo
      do i = 1, n
        write(*,*) (a(i,j), j = 1, n)
      enddo

c volani subrutin z Numerical Recipes

c redukce symetricke matice na tridiagonalni
      call tred2(a,n,np,d,e)

c a(np,np) ... na vystupu tred2 jde o transformacni matici, kterou dosazujeme do tqli

c vypocet vlastnich cisel a vektoru tridiagonalni matice
      call tqli(d,e,n,np,a)

c d(np)    ... na vystupu tqli jsou zde vlastni cisla
c a(np,np) ... byla nahrazena vlastnimi vektory

c trideni vlastnich cisel podle velikosti
      call srtidx(n,d,id)

c vypis vlastnich cisel (nejvetsi prvni)
      write(*,*) '# vlastni cisla matice a():'
      do i = n, 1, -1
        write(*,*) d(id(i))
      enddo
      write(*,*)

c vypis odpovidajicich vlastnich vektoru
      write(*,*) '# vlastni vektory matice a() v radcich:'
      do i = n, 1, -1
        do j = 1, n
          write(*,20) a(j,id(i))
20        format(f16.8,1x,$) 
        enddo
        write(*,*)
      enddo
      write(*,*)

      stop
      end


